﻿;=========================================== 環境定義
FixedClipMenuText := Object()
FixedClipText := Object()
FixedClipAddTime := Object()
ClipMenuText := Object()
ClipText := Object()
ClipAddTime := Object()
OnClipBoardChange := 0
IniFileName = %A_ScriptDir%\config\%A_ComputerName%_%A_UserName%.ini
ConfigFileName = %A_ScriptDir%\config\config.ini
MainIconName = %A_ScriptDir%\icon\showclip.ico
FifoIconName = %A_ScriptDir%\icon\showclipfifo.ico
FifoPasteIconName = %A_ScriptDir%\icon\showclipfifopaste.ico
;=========================================== アイコンロード
Menu TRAY,Icon,%MainIconName%
;=========================================== トレイメニューの構築
Menu Tray, Add, About, ShowAbout
Menu Tray, Add, Help, ShowHelp
Menu TRAY, Add	;区切り線
Menu Tray, Add, 再起動, ReloadApplication
Menu Tray, Add, 一時停止, SuspendApplication
Menu TRAY,Add	;区切り線
Menu Tray,Add,機能設定
Menu Tray,Add,履歴マネージャー
Menu Tray,Add,WEB検索
Menu TRAY,Add	;区切り線
Menu Tray, Add, 終了, ExitApplication
Menu Tray, NoStandard
Menu Tray, UnCheck, 一時停止
;================================================================= 初回起動時はiniファイルを自動作成する
IniRead,FirstRun,%IniFileName%,AUTOEXEC,StartUp,-1
If (FirstRun == -1) {
	;--------------- 初回起動時はiniファイルを自動作成する
	Filecopy,%A_ScriptDir%\config\default.ini,%IniFileName%
}
;=========================================== モード切替通知設定
IniRead,OnChangeModeBeep,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeBeep,1
IniRead,OnChangeModeToolTip,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeToolTip,1
IniRead,OnChangeModeToolTipDspTime,%IniFileName%,CHANGE_MODE_NOTIFY,OnChangeModeToolTipDspTime,800
;=========================================== 履歴設定
IniRead,MaxHistory,%IniFileName%,HISTORY_CONFIG,MaxHistory,10
IniRead,KeepMin,%IniFileName%,HISTORY_CONFIG,KeepMin,10
IniRead,MenuTextLen,%IniFileName%,HISTORY_CONFIG,MenuTextLen,60
;=========================================== キー連打ホットキーの設定
IniRead,KeyDoubleSens,%IniFileName%,DOUBLE_PUSH_HOTKEY,KeyDoubleSens,500
KeyDoubleSensNega := KeyDoubleSens * -1
KeyDoubleLCtrlRoutine := "Dummy"
KeyDoubleRCtrlRoutine := "Dummy"
;=========================================== オプション機能の利用有無と名称を取得する
Global UseOption := Object()
Global OptionName := Object()
Global OptionOrder := Object()
Loop {
	;--------------- オプション機能メニューの名称
	Key = OptionName%A_Index%
	IniRead,strWrk,%ConfigFileName%,OPTION_NAME,%Key%,-1
	If (strWrk == -1) {
		Break
	}
	OptionName[A_Index] := strWrk
	;--------------- オプション機能の利用有無
	Key = UseOption%A_Index%
	IniRead,strWrk,%IniFileName%,OPTION,%Key%,1
	UseOption[A_Index] := strWrk
	;--------------- オプション機能メニューの表示順
	Key = OptionOrder%A_Index%
	IniRead,strWrk,%IniFileName%,OPTION,%Key%,%A_Index%
	OptionOrder[A_Index] := strWrk
}
;=========================================== オプション機能はメニューを分けるか？
IniRead,SplitMenu,%IniFileName%,OPTION,SplitMenu,1
If (SplitMenu == 1) {
	OptionMenuName := "mnClipBoardHistoryOption"
}Else{
	OptionMenuName := "mnClipBoardHistory"		
}
;=========================================== 改行とタブ
IniRead,ChrLF,%IniFileName%,LFCR,ChrLF,<<<!LF>>>
IniRead,ChrCR,%IniFileName%,LFCR,ChrCR,<<<!CR>>>
IniRead,ChrTab,%IniFileName%,LFCR,ChrTab,<<<!TAB>>>
;=========================================== ホットキーの定義
loop {
	;--------------- 設定ファイルからホットキールーチン情報を読み込む
	KeyNo := A_Index
	Key = HotkeyRoutine%KeyNo%
	IniRead,HotkeyRoutine,%ConfigFileName%,HOTKEY,%Key%,-1
	If (HotkeyRoutine == -1) {
		Break
	}
	Loop {
		;--------------- iniファイルからホットキー情報を読み込む
		Key = Hotkey%KeyNo%_%A_Index%
		IniRead,strWrk,%IniFileName%,HOTKEY,%Key%,-1
		If (strWrk == -1) {
			Break
		}
		;--------------- ホットキーを割り当てる
		IfInString, strWrk, Dbl
		{
			If (strWrk == "DblLCtrl") {
				KeyDoubleLCtrlRoutine := HotkeyRoutine
			}
			If (strWrk == "DblRCtrl") {
				KeyDoubleRCtrlRoutine := HotkeyRoutine
			}
			If (strWrk == "DblLAlt") {
				KeyDoubleLAltRoutine := HotkeyRoutine
			}
			If (strWrk == "DblRAlt") {
				KeyDoubleRAltRoutine := HotkeyRoutine
			}
		}Else{
			Hotkey, %strWrk%, %HotkeyRoutine%
		}
	}
}
;=========================================== ホットキーに割り当て可能なキー情報を取得する（オプション機能設定画面で使用）
Global HK_ModifierDsp := Object()
Global HK_ModifierEnc := Object()
Global HK_KeyAssignDsp := Object()
Global HK_KeyAssignEnc := Object()
Loop {
	;--------------- 修飾キー(表示用)
	Key = HotkeyModifierKey%A_Index%
	IniRead,strWrk,%ConfigFileName%,HOTKEY,%Key%,-1
	If (strWrk == -1) {
		Break
	}
	HK_ModifierDsp[A_Index] := strWrk
	;--------------- ホットキー追加用のドロップダウンリストの項目を設定する
	If (A_Index == 1) {
		ModifierDDL = %strWrk%
	}Else{
		ModifierDDL = %ModifierDDL%|%strWrk%
	}
	;--------------- 修飾キー(実行用)
	Key = HotkeyModifierKeyEnc%A_Index%
	IniRead,strWrk,%ConfigFileName%,HOTKEY,%Key%,-1
	HK_ModifierEnc[A_Index] := strWrk
	;--------------- 修飾キーの最大個数を保存する
	HotkeyModifierMaxCount := A_Index
}
i := HotkeyModifierMaxCount - 1
Loop %i% {
	;--------------- マウスにホットキーを割り当てる場合に必ず修飾キーを指定するように「修飾キーを指定していしない」を修飾キー(表示用)から除外する
	Key = HotkeyModifierKey%A_Index%
	IniRead,strWrk,%ConfigFileName%,HOTKEY,%Key%,-1
	;--------------- ホットキー追加用のドロップダウンリストの項目を設定する
	If (A_Index == 1) {
		ModifierForMouseDDL = %strWrk%
	}Else{
		ModifierForMouseDDL = %ModifierForMouseDDL%|%strWrk%
	}	
}
Loop {
	;--------------- キー(表示用)
	Key = HotkeyAssign%A_Index%
	IniRead,strWrk,%ConfigFileName%,HOTKEY,%Key%,-1
	If (strWrk == -1) {
		Break
	}
	;--------------- ホットキー追加用のドロップダウンリストの項目を設定する
	If (A_Index == 1) {
		HotkeyAssignDDL = %strWrk%
	}Else{
		HotkeyAssignDDL = %HotkeyAssignDDL%|%strWrk%
	}
	HK_KeyAssignDsp[A_Index] := strWrk
	;--------------- キー(実行用)
	Key = HotkeyAssignEnc%A_Index%
	IniRead,strWrk,%ConfigFileName%,HOTKEY,%Key%,-1
	HK_KeyAssignEnc[A_Index] := strWrk
}
;=========================================== オプションメニューを構築
For index, OptOdr in OptionOrder {
	If (UseOption[OptOdr] == 1) {
		Gosub BuildOptionMenu%OptOdr%
	}
}
If (SplitMenu == 0) {
	;--------------- 区切り線
	Menu %OptionMenuName%, Add
}
;=========================================== 固定テキストをiniファイルから読み込んで固定テキストメニューを構築
;--------------- iniファイルの固定テキストを固定テキスト配列に格納する
loop {
	Section = FIXEDITEM%A_Index%
	;--------------- 履歴メニュー表示テキスト
	IniRead,strWrk,%IniFileName%,%Section%,FixedClipMenuText,-1
	If (strWrk == -1) {
		Break
	}
	FixedClipMenuText[A_Index] := strWrk
	;--------------- 履歴テキスト
	IniRead,strWrk,%IniFileName%,%Section%,FixedClipText,-1	
	;--------------- 改行とタブを復元
	Gosub DecodeLFCR_TAB
	FixedClipText[A_Index] := strWrk
	;--------------- 保存日時
	IniRead,strWrk,%IniFileName%,%Section%,FixedCLipAddTime,-1
	FixedClipAddTime[A_Index] := strWrk
}
;--------------- 固定テキスト配列の内容で固定テキストメニューを構築する
While StrLen(FixedClipText[A_Index]) > 0 {
	;--------------- タブを置換
	strWrk := FixedClipText[A_Index]
	StringReplace, strWrk, strWrk, %A_Tab%,<tab>,All
	;--------------- 改行を置換
	StringReplace, strWrk, strWrk, `n, <改行>, ReplaceAll
	StringReplace, strWrk, strWrk, `r, , ReplaceAll
	;--------------- &を置換(&があるとメニュー表示が正しく構築されないため)
	StringReplace, strWrk, strWrk, &, ＆, ReplaceAll
	;--------------- 指定された文字数を抽出
	StringMid, strWrk, strWrk, 1,MenuTextLen
	;--------------- 固定テキストメニューを配列に保存
	FixedClipMenuText[A_Index] := strWrk
	;--------------- アクセスキーを取得する
	;Gosub GetAccessKey
	;--------------- 履歴メニューを構築
	;Menu mnClipBoardHistory, Add, %AccessKey%: %strWrk%, PasteFixedClipBoardHistory
	;Menu mnClipBoardHistory, Check, %AccessKey%: %strWrk%
	Menu mnClipBoardHistory, Add, %A_Index%: %strWrk%(&X), PasteFixedClipBoardHistory
	Menu mnClipBoardHistory, Check, %A_Index%: %strWrk%(&X)
}
;--------------- 区切り線を追加する
If (StrLen(FixedClipText[1]) > 0) {
	Menu mnClipBoardHistory, Add
}
;=========================================== クリップボード履歴をiniファイルから読み込んで履歴メニューを構築
;--------------- iniファイルのクリップボード履歴をクリップボード配列に格納する
loop {
	Section = HISTORY%A_Index%
	;--------------- 履歴メニュー表示テキスト
	IniRead,strWrk,%IniFileName%,%Section%,ClipMenuText,-1
	If (strWrk == -1) {
		Break
	}
	ClipMenuText[A_Index] := strWrk
	;--------------- 履歴テキスト
	IniRead,strWrk,%IniFileName%,%Section%,ClipText,-1	
	;--------------- 改行とタブを復元
	Gosub DecodeLFCR_TAB
	ClipText[A_Index] := strWrk
	;--------------- 保存日時
	IniRead,strWrk,%IniFileName%,%Section%,CLipAddTime,-1
	ClipAddTime[A_Index] := strWrk
}
;--------------- クリップボード配列の内容で履歴メニューを構築
Gosub BuildClipBoardMenu
;=========================================== 前回終了時に設定画面が表示されていた場合は再表示する
IniRead,strWrk,%IniFileName%,AUTOEXEC,StartUp,-1
If (strWrk == -1) {
	;--------------- 初回起動時は機能設定画面を表示する
	Gosub 機能設定
}Else{
	If (strWrk == 1) {
		IniRead,strWrk,%IniFileName%,AUTOEXEC,ShowConfigPanel,0
		Gosub %strWrk%
	}
}
;=========================================== AutoExec終了
Return
;=========================================== 関数・サブルーチンをインクルード
;-------------------------------------- About & Help
#Include %A_ScriptDir%\SubAboutAndHelp.ahk
;-------------------------------------- 機能設定
#Include %A_ScriptDir%\SubConfigPanel.ahk
#Include %A_ScriptDir%\SubFixedPhrasePanel.ahk
#Include %A_ScriptDir%\SubEncloseTextPanel.ahk
#Include %A_ScriptDir%\SubWebSearchPanel.ahk
#Include %A_ScriptDir%\SubHistoryManager.ahk
#Include %A_ScriptDir%\SubWebSearchWindow.ahk
;=========================================== スクリプトをリロードする
ReloadApplication:
	Reload
Return
;=========================================== スクリプトを一時停止する
SuspendApplication:
	Menu Tray,ToggleCheck, 一時停止
	If (A_IsSuspended == 1) {
		Suspend Off
	}Else{
		Suspend On
	}
Return
;============================================ スクリプトを終了する
ExitApplication:
	Msgbox 4,終了確認,アプリケーションを終了しますか？
	IfMsgBox, Yes
	{
		ExitApp
	}
Return
;=========================================== クリップボードが変化した時
OnClipboardChange:
	;--------------- クリップボードがFIFOモードになっているか？
	If (QueueMode == 1) {
		;--------------- クリップボードがFIFOペースト実行中ではないか？
		If (OnClipBoardFIFOpaste != 1 && Clipboard) {
			;--------------- クリップボードの内容をストックしていく
			CpyIndex += 1
			Queue[CpyIndex] := Clipboard
			;--------------- 処理状態を通知する
			If (OnChangeModeBeep == 1) {
				SoundBeep 700,70
			}
			If (OnChangeModeToolTip == 1) {
				ShowSplashImage(Clipboard)
				SetTimer RemoveSplashImage,%OnChangeModeToolTipDspTime%
			}
		}
		Return
	}
	;--------------- 新しいクリップボードが作成されたか？
	If (OnClipBoardChange == 1) {
		;--------------- クリップボードがテキスト形式のときだけ処理する
		If (StrLen(Clipboard) > 0) {
			;--------------- クリップボード履歴メニューを一旦削除する
			ix := 0
			While StrLen(ClipMenuText[A_Index]) > 0 {
				ix += 1
				StringRight, AccessKey, A_Index, 1
				StringLeft, NoLeftDigit, A_Index, StrLen(A_Index) -1
				strWrk := NoLeftDigit . "&" . AccessKey . ": " . ClipMenuText[A_Index]
				Menu mnClipBoardHistory, Delete, %strWrk%
			}
			;--------------- iniファイルの内容を一旦削除する
			loop {
				Section = HISTORY%A_Index%
				IniRead,strWrk,%IniFileName%,%Section%,ClipMenuText,-1
				If (strWrk == -1) {
					Break
				}
				IniDelete,%IniFileName%,%Section%
			}
			;--------------- クリップボード配列の内容で履歴メニューを再構築
			Gosub BuildClipBoardMenu
		}
	}Else{
		;--------------- 次にクリップボードが変化したときに履歴を取るように判定変数の値を変更する
		OnClipBoardChange := 1
	}
Return
;=========================================== クリップボード配列の内容で履歴メニューを構築
BuildClipBoardMenu:
	;--------------- クリップボードに文字列が格納されていて、直前の内容と違っているときは、過去のクリップボード履歴をずらす
	If (StrLen(Clipboard) > 0 && Clipboard != ClipText[1]) {
		;--------------- 現在日時を取得する
		NowIime := A_Now
		;--------------- 過去のクリップボード履歴をずらす
		ixa := ix
		Loop %ix% {
			ixb := ixa + 1
			;--------------- 最大保管数以内の履歴は、履歴位置をずらして保管する
			If (ixa < MaxHistory) {
				ClipText[ixb] := ClipText[ixa]
				ClipAddTime[ixb] := ClipAddTime[ixa]
			}Else{
				;--------------- 最大保管数を超えた履歴の保持期限を求める
				LimitIime := ClipAddTime[ixa]
				EnvAdd, LimitIime, %KeepMin%, Minutes
				;--------------- 最大保管数を超えた履歴は、保持時間以内のものだけ保管する
				If (NowIime < LimitIime) {
					ClipText[ixb] := ClipText[ixa]
					ClipAddTime[ixb] := ClipAddTime[ixa]
				}Else{
					ClipText[ixa] := ""
					ClipAddTime[ixa] := ""
					ClipMenuText[ixa] := ""
				}
			}
			ixa -= 1
		}
		;--------------- 最新のクリップボードを配列の先頭に格納する
		ClipText[1] := Clipboard
		;--------------- クリップボード格納日時を保管する
		ClipAddTime[1] := A_Now
	}
	;--------------- クリップボード配列の内容で履歴メニューを構築する
	While StrLen(ClipText[A_Index]) > 0 {
		;--------------- タブを置換
		strWrk := ClipText[A_Index]
		StringReplace, strWrk, strWrk, %A_Tab%,<tab>,All
		;--------------- 改行を置換
		StringReplace, strWrk, strWrk, `n, <改行>, ReplaceAll
		StringReplace, strWrk, strWrk, `r, , ReplaceAll
		;--------------- &を置換(&があるとメニュー表示が正しく構築されないため)
		StringReplace, strWrk, strWrk, &, ＆, ReplaceAll
		;--------------- 指定された文字数を抽出
		StringMid, strWrk, strWrk, 1,MenuTextLen
		;--------------- 履歴メニューを配列に保存
		ClipMenuText[A_Index] := strWrk
		;--------------- アクセスキーを取得する
		Gosub GetAccessKey
		;--------------- 履歴メニューを構築
		Menu mnClipBoardHistory, Add, %AccessKey%: %strWrk%, PasteClipBoardHistory
		;--------------- iniファイルに保存する
		Section = HISTORY%A_Index%
		;--------------- 履歴メニュー表示テキストをiniファイルに保存
		IniWrite, %strWrk%, %IniFileName%, %Section%, ClipMenuText
		;--------------- 履歴テキスト
		strWrk := ClipText[A_Index]
		;--------------- 改行を置換
		Gosub EncodeLFCR_TAB
		;--------------- 履歴テキストをiniファイルに保存
		IniWrite, %strWrk%, %IniFileName%, %Section%, ClipText
		;--------------- 保存日時をiniファイルに保存
		strWrk := ClipAddTime[A_Index]
		IniWrite, %strWrk%, %IniFileName%, %Section%, CLipAddTime
	}
Return
;=========================================== 定型文をiniファイルから読み込んでメニューを構築
BuildOptionMenu1:
	loop {
		;--------------- 定型文・表示順情報を読み込む
		Key = FIXED_PHRASE_ORDER%A_Index%
		IniRead, FP_Order, %IniFileName%, FIXED_PHRASE_ORDER, %Key%, -1
		If (FP_Order == -1) {
			Break
		}
		;--------------- 定型文・グループメニューを読み込む
		Section = FIXED_PHRASE%FP_Order%
		IniRead, FP_MenuGroup, %IniFileName%, %Section%, MenuGroup, -1
		;--------------- 定型文・コンテンツメニューを構築する
		FP_No := A_Index
		MenuCount := 0
		loop {
			Section = FIXED_PHRASE%FP_Order%
			Key = MenuText%A_Index%
			IniRead, FP_MenuText, %IniFileName%, %Section%, %Key%, -1
			If (FP_MenuText == -1) {
				Break
			}	
			;--------------- アクセスキーを取得する
			Gosub GetAccessKey
			;--------------- 履歴メニューを構築
			Menu mnFixedPhaseMenu%FP_No%, Add, %FP_No%-%AccessKey%: %FP_MenuText%, PasteFixedPhrase
			MenuCount := 1
		}
		If (MenuCount == 1) {
			;--------------- アクセスキーを取得する
			Gosub GetAccessKey
			;--------------- 定型文・グループメニューを構築する
			Menu mnFixedPhase, Add, %AccessKey%: %FP_MenuGroup%, :mnFixedPhaseMenu%A_Index%
		}
	}
	;--------------- 定型文・親メニューを構築する
	If (MenuCount > 0) {
		MenuName := OptionName[1]
		Menu %OptionMenuName%, Add, %MenuName%(&F), :mnFixedPhase
	}
Return
;=========================================== テキストの挟み込み機能をiniファイルから読み込んでメニューを構築
BuildOptionMenu2:
	MenuName := OptionName[2]
	loop {
		;--------------- メニューテキストを読み込む
		Section = ENCLOSE_TEXT%A_Index%
		IniRead, ET_MenuText, %IniFileName%, %Section%, MenuText, -1
		If (ET_MenuText == -1) {
			Break
		}
		;--------------- アクセスキーを取得する
		Gosub GetAccessKey
		;--------------- テキストの挟み込みメニューを構築する
		Menu mnEncloseTextMenu, Add, %AccessKey%: %ET_MenuText%, EncloseText
		;--------------- テキストの挟み込み・親メニューを構築する
		Menu %OptionMenuName%, Add, %MenuName%(&C), :mnEncloseTextMenu
	}
Return
;=========================================== WEB検索機能をiniファイルから読み込んでメニューとホットキーを構築
BuildOptionMenu3:
	MenuName := OptionName[3]
	loop {
		;--------------- WEB検索機能メニューテキストを読み込む
		Section = WEB_SEARCH1_%A_Index%
		IniRead, WebSearchMenuText, %IniFileName%, %Section%, MenuText, -1
		If (WebSearchMenuText == -1) {
			Break
		}
		;--------------- アクセスキーを取得する
		Gosub GetAccessKey
		;--------------- WEB検索メニューを構築する
		Menu mnWebSearchMenu, Add, %AccessKey%: %WebSearchMenuText%, WebSearchByMenu
		;--------------- WEB検索・親メニューを構築する
		Menu %OptionMenuName%, Add, %MenuName%(&S), :mnWebSearchMenu
		;--------------- WEB検索機能ホットキーを読み込む
		IniRead, WebSearchHotkey, %IniFileName%, %Section%, Hotkey, -1
		If (StrLen(WebSearchHotkey) > 0) {
			;--------------- ホットキーを割り当てる
			IfInString, WebSearchHotkey, Dbl
			{
				If (WebSearchHotkey == "DblLCtrl") {
					KeyDoubleLCtrlRoutine := "WebSearchByHotkey"
				}
				If (WebSearchHotkey == "DblRCtrl") {
					KeyDoubleRCtrlRoutine := "WebSearchByHotkey"
				}
			}Else{
				Hotkey, %WebSearchHotkey%, WebSearchByHotkey
			}
		}
	}
Return
;=========================================== キー連打でメニュー表示
ShinglePush:
	If (A_ThisHotkey == "~LCtrl") {
		send {blind}{LCtrl}
	}
	If (A_ThisHotkey == "~RCtrl") {
		send {blind}{RCtrl}
	}
Return
~LCtrl::
~RCtrl::
	If (A_TickCount < KeyDouble) {
		SetTimer, ShinglePush, OFF
		KeyDouble := 0
		If (A_ThisHotkey == "~LCtrl") {
			Gosub %KeyDoubleLCtrlRoutine%
		}
		If (A_ThisHotkey == "~RCtrl") {
			Gosub %KeyDoubleRCtrlRoutine%
		}
		Return
	}else{
		KeyDouble := A_TickCount
		KeyDouble := KeyDouble + KeyDoubleSens
		SetTimer, ShinglePush, %KeyDoubleSensNega%
	}
	If (A_ThisHotkey == "~LCtrl") {
		KeyWait, LCtrl
	}
	If (A_ThisHotkey == "~RCtrl") {
		KeyWait, RCtrl
	}
Return
;=========================================== キー連打ホットキーが設定されていないときのダミールーチン
Dummy:
Return
;=========================================== クリップボード履歴メニューを表示する
ShowMenu:
	mnX := A_CaretX
	mnY := A_CaretY
	;--------------- メニュー未構築の場合はエラーを回避する
	Menu mnClipBoardHistory,UseErrorLevel
	Menu mnClipBoardHistory,Show,%mnX%,%mnY%
	Menu mnClipBoardHistory,UseErrorLevel,off
Return
;=========================================== オプションメニューを表示する
ShowOptionMenu:
	mnX := A_CaretX
	mnY := A_CaretY
	;--------------- メニュー未構築の場合はエラーを回避する
	Menu %OptionMenuName%,UseErrorLevel
	Menu %OptionMenuName%,Show,%mnX%,%mnY%
	Menu %OptionMenuName%,UseErrorLevel,off
Return
;=========================================== 固定テキストを貼り付ける
PasteFixedClipBoardHistory:
	;--------------- 選択されたメニューの選択番号を取得する
	StringReplace, MenuItem, A_ThisMenuItem, &
	StringGetPos, DelimtPos, MenuItem, :
	StartPos := 1
	DelimtLen := DelimtPos + 1 - StartPos
	StringMid, ClipNo, MenuItem, StartPos, DelimtLen
	;--------------- 履歴を取らないように判定変数の値を変更する
	OnClipBoardChange := 0
	;--------------- 選択された履歴を貼り付ける
	Clipboard := FixedClipText[ClipNo]
	ClipWait 1
	send ^v
Return
;=========================================== クリップボード履歴を貼り付ける
PasteClipBoardHistory:
	;--------------- 選択されたメニューの選択番号を取得する
	StringReplace, MenuItem, A_ThisMenuItem, &
	StringGetPos, DelimtPos, MenuItem, :
	StartPos := 1
	DelimtLen := DelimtPos + 1 - StartPos
	StringMid, ClipNo, MenuItem, StartPos, DelimtLen
	;--------------- 履歴を取らないように判定変数の値を変更する
	OnClipBoardChange := 0
	;--------------- 選択された履歴を貼り付ける
	Clipboard := ClipText[ClipNo]
	ClipWait 1
	send ^v
	;--------------- クリップボード格納日時を保管（更新）する
	ClipAddTime[ClipNo] := A_Now
Return
;=========================================== 定型文を貼り付ける
PasteFixedPhrase:
	;--------------- 選択されたメニューのグループ番号を取得する
	StringReplace, MenuItem, A_ThisMenuItem, &
	StringGetPos, DelimtPos, MenuItem, -
	StartPos := 1
	DelimtLen := DelimtPos + 1 - StartPos
	StringMid, FP_Order, MenuItem, StartPos, DelimtLen
	IniRead, FP_GNo, %IniFileName%, FIXED_PHRASE_ORDER, FIXED_PHRASE_ORDER%FP_Order%, 1
	;--------------- 選択されたメニューのコンテンツ番号を取得する
	StringGetPos, StartPos, MenuItem, -
	StartPos += 2
	StringGetPos, DelimtPos, MenuItem, :
	DelimtLen := DelimtPos + 1 - StartPos
	StringMid, FP_CNo, MenuItem, StartPos, DelimtLen
	;--------------- 選択された定型文を取得する
	Section = FIXED_PHRASE%FP_GNo%
	Key = Contents%FP_CNo%
	IniRead, strWrk, %IniFileName%, %Section%, %Key%, -1
	;---------- 改行とタブを復元
	Gosub DecodeLFCR_TAB
	;--------------- 履歴を取らないように判定変数の値を変更する
	OnClipBoardChange := 0
	;--------------- 選択された定型文を貼り付ける
	Clipboard := strWrk
	ClipWait 1
	send ^v
Return
;=========================================== 選択範囲のテキストを挟み込む
EncloseText:
	;--------------- 選択されたメニューの選択番号を取得する
	StringReplace, MenuItem, A_ThisMenuItem, &
	StringGetPos, DelimtPos, MenuItem, :
	StartPos := 1
	DelimtLen := DelimtPos + 1 - StartPos
	StringMid, EC_No, MenuItem, StartPos, DelimtLen
	;--------------- クリップボードをクリアする
	Clipboard := 
	;--------------- 現在選択されているテキストをクリップボードに取り込む
	send ^c
	ClipWait 1
	SelectedText := Clipboard
	;--------------- 挟み込むテキストを取得する
	Section = ENCLOSE_TEXT%EC_No%
	IniRead, LeftText, %IniFileName%, %Section%, LeftText, -1
	IniRead, RightText, %IniFileName%, %Section%, RightText, -1
	EncloseText = %LeftText%%SelectedText%%RightText%
	;--------------- 挟み込んだテキストを貼り付ける
	Clipboard := EncloseText
	ClipWait 1
	send ^v
Return
;=========================================== 選択文字でWEB検索
WebSearchByMenu:
	;--------------- 選択されたメニューの選択番号を取得する
	StringReplace, MenuItem, A_ThisMenuItem, &
	StringGetPos, DelimtPos, MenuItem, :
	StartPos := 1
	DelimtLen := DelimtPos + 1 - StartPos
	StringMid, WS_No, MenuItem, StartPos, DelimtLen
	;--------------- 選択文字でWEB検索
	Gosub WebSearchBySelectedText
Return
;=========================================== 選択文字でWEB検索機能をホットキーで起動する
WebSearchByHotkey:
	loop {
		;--------------- WEB検索機能ホットキーを読み込む
		Section = WEB_SEARCH1_%A_Index%
		IniRead, WebSearchHotkey, %IniFileName%, %Section%, Hotkey, -1
		If (WebSearchHotkey == -1) {
			Break
		}
		If (WebSearchHotkey == A_ThisHotkey || (WebSearchHotkey == "DblLCtrl" && A_ThisHotkey == "~LCtrl") || (WebSearchHotkey == "DblRCtrl" && A_ThisHotkey == "~RCtrl")) {
			WS_No := A_Index
			;--------------- 選択文字でWEB検索
			Gosub WebSearchBySelectedText
			Break
		}
	}
Return
;=========================================== 選択文字でWEB検索
WebSearchBySelectedText:
	;--------------- 履歴を取らないように判定変数の値を変更する
	OnClipBoardChange := 0
	;--------------- クリップボードをクリアする
	Clipboard := 
	;--------------- 履歴を取らないように判定変数の値を変更する
	OnClipBoardChange := 0
	;--------------- 現在選択されているテキストをクリップボードに取り込む
	Sleep 100
	send ^c
	ClipWait 1
	SelectedText := UriEncode(Clipboard)
	Gosub Websearch
Return
;=========================================== WEB検索
WebSearch:
	;--------------- 追記検索モードのときは前回の検索ワードを追加する
	Section = WEB_SEARCH1_%WS_No%
	IniRead, WebSearchMode, %IniFileName%, %Section%, Mode, -1
	If (WebSearchMode == 1) {
		SelectedText = %PrevWord% %SelectedText%
	}
	;--------------- 検索エンジンのURLを取得する（iniファイルの読み込みが間に合わず？取得できないことがあるので、取得できるまで繰り返し処理する）
	WebSearchEngineURL := -1
	While WebSearchEngineURL == -1 {
		IniRead, WebSearchEngineURL, %IniFileName%, %Section%, URL, -1
		;--------------- 検索ワード末尾に追加する文字を取得する
		IniRead, WebSearchSuffix, %IniFileName%, %Section%, Suffix, -1
		IF (WebSearchSuffix == -1) {
			WebSearchSuffix := ""
		}
	}
	;--------------- 検索URLを設定する
	WebSearchURL = %WebSearchEngineURL%%SelectedText%%WebSearchSuffix%
	;--------------- 検索を実行する
	Run %WebSearchURL%
	;--------------- Twitter検索以外のときはデフォルトブラウザをアクティブにする
	If (InStr(WebSearchURL, "https://twitter.com/") == 0) {
		;--------------- デフォルトブラウザの実行ファイルを取得する
		RegRead, DftBrws, HKEY_CLASSES_ROOT, http\shell\open\command
		;--------------- レジストリに記録されている起動オプションを削除する
		StringSplit, DftBrwExe, DftBrws, ., ""
		DftBrwExe1 = %DftBrwExe1%.exe
		;--------------- 検索結果が表示されるまで待つ
		SetTitleMatchMode,2
		WinWait, ahk_exe %DftBrwExe1%, %SelectedText%, 0
		;--------------- デフォルトブラウザをアクティブにする
		WinActivate, ahk_exe %DftBrwExe1%
		SetTitleMatchMode,1
	}
	;--------------- 検索ワードを保存する
	PrevWord := SelectedText
Return
;=========================================== アクセスキーを取得する
GetAccessKey:
	;--------------- アクセスキーにする文字を取得
	StringRight, AccessKey, A_Index, 1
	;--------------- メニュー番号の左側の文字を取得
	StringLeft, NoLeftDigit, A_Index, StrLen(A_Index) -1
	;--------------- アクセスキーをセットする
	AccessKey = %NoLeftDigit%&%AccessKey%
Return
;=========================================== 改行とタブを置換
EncodeLFCR_TAB:
	StringReplace, strWrk, strWrk, `n, %ChrLF%, ReplaceAll
	StringReplace, strWrk, strWrk, `r, %ChrCR%, ReplaceAll
	StringReplace, strWrk, strWrk, %A_Tab%, %ChrTab%, ReplaceAll
Return
;=========================================== 改行とタブを復元
DecodeLFCR_TAB:
	StringReplace, strWrk, strWrk, %ChrLF%, `n, ReplaceAll
	StringReplace, strWrk, strWrk, %ChrCR%, `r, ReplaceAll
	StringReplace, strWrk, strWrk, %ChrTab%, %A_Tab%, ReplaceAll
Return
;=========================================== クリップボードのFIFOモードをオン・オフする
ChangeClipBoardFIFOmode:
	;--------------- クリップボードがFIFOモードになっているか？
	If (QueueMode == 1) {
		;--------------- クリップボードのFIFOモードを解除する
		QueueMode := 0
		;--------------- アイコンを変更する
		Menu TRAY,Icon,%MainIconName%
		;--------------- 処理状態を通知する
		If (OnChangeModeBeep == 1) {
			SoundBeep,800,100
		}
		If (OnChangeModeToolTip == 1) {
			ShowSplashImage("FIFOモードを解除しました")
			SetTimer RemoveSplashImage,%OnChangeModeToolTipDspTime%
		}
	}Else{
		;--------------- クリップボードのFIFOモードに変更する
		Queue := Object()
		QueueMode := 1
		CpyIndex  := 0
		PstIndex  := 0
		Clipboard :=
		;--------------- アイコンを変更する
		Menu TRAY,Icon,%FifoIconName%
		;--------------- 処理状態を通知する
		If (OnChangeModeBeep == 1) {
			SoundBeep 700,70
		}
		If (OnChangeModeToolTip == 1) {
			ShowSplashImage("FIFOモードに変更しました")
			SetTimer RemoveSplashImage,%OnChangeModeToolTipDspTime%
		}
	}
Return
;=========================================== クリップボードのFIFOペーストを再開する
RestartClipBoardFIFOpaste:
	;--------------- クリップボードがキューにストックされているか？
	If (StrLen(Queue[1]) > 0) {
		;--------------- クリップボードのFIFOペーストを再開する
		QueueMode := 1
		PstIndex  := 0
		;--------------- アイコンを変更する
		Menu TRAY,Icon,%FifoPasteIconName%
		;--------------- 処理状態を通知する
		If (OnChangeModeBeep == 1) {
			SoundBeep,700,100
		}
		If (OnChangeModeToolTip == 1) {
			ShowSplashImage("FIFO貼り付けモードに変更しました")
			SetTimer RemoveSplashImage,%OnChangeModeToolTipDspTime%
		}
	}
Return
;=========================================== クリップボードのFIFOペースト
ClipBoardFIFOpaste:
	;--------------- FIFOモードになっており、かつキューにストックされているか？
	If (QueueMode == 1 && StrLen(Queue[1]) > 0) {
		PstIndex += 1
		;--------------- アイコンを変更する
		Menu TRAY,Icon,%FifoPasteIconName%
		;--------------- 処理状態を通知する
		If (OnChangeModeBeep == 1) {
			SoundBeep,700,100
		}
		If (OnChangeModeToolTip == 1) {
			Msg = %PstIndex%番目を貼り付け
			ShowSplashImage(Msg)
			SetTimer RemoveSplashImage,%OnChangeModeToolTipDspTime%
		}
		;--------------- クリップボードのFIFOペースト
		Clipboard := Queue[PstIndex]
		ClipWait
		Send ^v
		OnClipBoardFIFOpaste = 1
		;--------------- キューの末尾に到達したか？
		If (PstIndex == CpyIndex) {
			;--------------- クリップボードのFIFOペーストを終了する
			QueueMode := 0
			;--------------- アイコンを変更する
			Menu TRAY,Icon,%MainIconName%
			If (OnChangeModeBeep == 1) {
				SoundBeep,800,100
			}
			;--------------- 処理状態を通知する
			If (OnChangeModeToolTip == 1) {
				ShowSplashImage("FIFO貼り付けを終了しました")
				SetTimer RemoveSplashImage,%OnChangeModeToolTipDspTime%
			}
			OnClipBoardFIFOpaste = 0
		}
	}Else{
		;--------------- 通常の貼り付け
		send ^v
	}
Return
;------------------------------------------------ ツールチップ（スプラッシュイメージ）を表示する
ShowSplashImage(text) {
	SplashImage,,B1 FM12 CWFFFFA2,,%text%
}
;------------------------------------------------ 一定時間経過したらツールチップ（スプラッシュイメージ）を閉じる
RemoveSplashImage:
	SetTimer RemoveSplashImage,off
	SplashImage,off
Return
;------------------------------------------------ URLエンコード
; AutoHotkeyフォーラムに公開されたスクリプトを使用
; https://autohotkey.com/board/topic/75390-ahk-l-unicode-uri-encode-url-encode-function/
;
; modified from jackieku's code (http://www.autohotkey.com/forum/post-310959.html#310959)
UriEncode(Uri, Enc = "UTF-8")
{
	StrPutVar(Uri, Var, Enc)
	f := A_FormatInteger
	SetFormat, IntegerFast, H
	Loop
	{
		Code := NumGet(Var, A_Index - 1, "UChar")
		If (!Code)
			Break
		If (Code >= 0x30 && Code <= 0x39 ; 0-9
			|| Code >= 0x41 && Code <= 0x5A ; A-Z
			|| Code >= 0x61 && Code <= 0x7A) ; a-z
			Res .= Chr(Code)
		Else
			Res .= "%" . SubStr(Code + 0x100, -1)
	}
	SetFormat, IntegerFast, %f%
	Return, Res
}

UriDecode(Uri, Enc = "UTF-8")
{
	Pos := 1
	Loop
	{
		Pos := RegExMatch(Uri, "i)(?:%[\da-f]{2})+", Code, Pos++)
		If (Pos = 0)
			Break
		VarSetCapacity(Var, StrLen(Code) // 3, 0)
		StringTrimLeft, Code, Code, 1
		Loop, Parse, Code, `%
			NumPut("0x" . A_LoopField, Var, A_Index - 1, "UChar")
		StringReplace, Uri, Uri, `%%Code%, % StrGet(&Var, Enc), All
	}
	Return, Uri
}

StrPutVar(Str, ByRef Var, Enc = "")
{
	Len := StrPut(Str, Enc) * (Enc = "UTF-16" || Enc = "CP1200" ? 2 : 1)
	VarSetCapacity(Var, Len, 0)
	Return, StrPut(Str, &Var, Enc)
}
